<template>
  <v-container>
    <v-dialog v-model="dialog" persistent max-width="50%">
      <v-card>
        <v-card-title>
          <span v-text="title" />
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="6">
                <v-text-field label="ID*" v-model="role.id" required :readonly="isEdit" :error-messages="error_payload.id"
                              @input="setResetError"
                              @blur="setResetError" />
              </v-col>
              <v-col cols="6">
                <v-text-field label="Name*" v-model="role.name" :disabled="statusProgress" required :error-messages="error_payload.name"
                              @input="setResetError"
                              @blur="setResetError" />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12">
                <v-combobox
                    :disabled="statusProgress"
                    v-model="roleMenuParents"
                    :items="menuParents"
                    item-text="name"
                    item-value="id"
                    label="Menu Parent*"
                    multiple
                    chips
                    @change="doChangeMenuParents(roleMenuParents)"
                    return-object
                    :error-messages="error_payload.roleMenuParents"
                    @input="setResetError"
                    @blur="setResetError"
                />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12">
                <v-combobox
                    :disabled="statusProgress"
                    v-model="roleMenuChilds"
                    :items="menuChilds"
                    item-text="name"
                    item-value="id"
                    label="Menu Childs*"
                    multiple
                    chips
                    return-object
                    :error-messages="error_payload.roleMenuChilds"
                    @input="setResetError"
                    @blur="setResetError"
                />
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue darken-1" text @click="doSaveOrUpdate" :disabled="statusProgress">Simpan</v-btn>
          <v-btn color="blue darken-1" text @click="doReset" :disabled="statusProgress">Reset</v-btn>
          <v-btn color="blue darken-1" text @click="doClose" :disabled="statusProgress">Close</v-btn>
        </v-card-actions>
      </v-card>
      <DlgMsg ref="dlgMsg" />
      <Loading ref="loading" :dlg-loading="statusProgress" />
    </v-dialog>
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import roleService from "../service/RoleService";
import menuServices from "../service/MenuService";
import {checkError400, checkError404} from "../utils/util";

export default {
  name: "RoleForm",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      menuParents: [],
      menuChilds: [],
      menuComponents: [],
      roleMenuParents: [],
      roleMenuChilds: [],
      role: {
        id: null,
        name: null,
        menus: [],
      },
      error_payload: {
        id: [],
        name: [],
        roleMenuParents: [],
        roleMenuChilds: [],
      },
      title: null,
      dialog: false,
      isEdit: false,
      statusProgress: false,
    }
  },
  methods: {
    doClose() {
      this.dialog = false
    },
    async doAdd(title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.doReset()
      this.statusProgress = true
      this.doLoadMenuParents()
      this.statusProgress = false
    },
    doEdit(id, title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.statusProgress = true
      this.doLoadMenuParents()
      this.retrieveRole(id)
      this.statusProgress = false
    },
    doReset() {
      if (!this.isEdit)
        this.role.id = null
      this.role.name = null
      this.role.menus = []
      this.roleMenuParents = []
      this.roleMenuChilds = []
      this.setResetError()
    },
    setResetError() {
      this.error_payload.id = []
      this.error_payload.name = []
      this.error_payload.roleMenuParents = []
      this.error_payload.roleMenuChilds = []
    },
    async doSaveOrUpdate() {
      if (!this.validation()) {
        return
      }
      let data = this.role
      data.menus = []

      for (let i in this.roleMenuParents) {
        let menu = this.roleMenuParents[i]
        data.menus.push(menu)
      }

      for (let i in this.roleMenuChilds) {
        let menu = this.roleMenuChilds[i]
        data.menus.push(menu)
      }

      this.statusProgress = true
      if (!this.isEdit) {
        await this.doSave(data)
      } else {
        await this.doUpdate(data)
      }
      this.statusProgress = false
    },
    doSave(data) {
      roleService.store(data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              await this.$parent.doRefresh()
              this.doReset()
            }
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            checkError400(ex, this.$refs.dlgMsg, this.error_payload)
          })
    },
    doUpdate(data) {
      roleService.update(data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              await this.$parent.doRefresh()
              await window._VMA.$emit('REFRESH_TOKEN')
            }
            this.dialog = false
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            checkError400(ex, this.$refs.dlgMsg, this.error_payload)
          })
    },
    async retrieveRole(id) {
      this.statusProgress = true
      await roleService.getById(id)
          .then(async res => {
            let status = res.data.status
            this.roleMenuParents = []
            this.roleMenuChilds = []
            if (status === 'SUCCESS') {
              this.role = res.data.data
              for (let menu of this.role.menus) {
                if (menu.parent_id == null && menu.form_app == null) {
                  this.roleMenuParents.push(menu)
                } else if (menu.parent_id != null && menu.form_app != null) {
                  this.roleMenuChilds.push(menu)
                }
              }
              await this.doLoadMenuChilds(this.roleMenuParents)
            } else {
              this.$refs.dlgMsg.doOpenMsg(res.data.data.message)
            }
          }).catch(ex => {
            checkError404(ex, this.$refs.dlgMsg)
      })
      this.statusProgress = false
    },
    validation() {
      if (this.roleMenuParents.length === 0) {
        this.error_payload.roleMenuParents = ['Menu Parent harus diisi']

      }

      if (this.roleMenuChilds.length === 0) {
        this.error_payload.roleMenuChilds = ['Menu Child harus diisi']
      }

      if (this.error_payload.roleMenuParents.length > 0 || this.error_payload.roleMenuChilds.length > 0) {
        this.$refs.dlgMsg.doOpenMsg("data masukan tidak valid")
        return false
      }

      return true
    },
    doLoadMenuParents() {
      menuServices.getAll().then(resp => {
        let status = resp.data.status
        if (status === 'SUCCESS') {
          this.menuParents = []
          let menus = resp.data.data
          for (let menu of menus) {
            if (menu.parent_id == null && menu.form_app == null) {
              this.menuParents.push(menu)
            }
          }
        }
      })
    },
    async doChangeMenuParents(data) {
      this.statusProgress = true
      this.roleMenuChilds = []
      await this.doLoadMenuChilds(data)
      this.statusProgress = false
    },
    doLoadMenuChilds(datas) {
      this.menuChilds = []
      for (let data of datas) {
        menuServices.getByParentId(data.id).then(resp => {
          let status = resp.data.status
          if (status === 'SUCCESS') {
            let menus = resp.data.data
            for (let menu of menus) {
              if (menu.parent_id != null && menu.form_app != null) {
                this.menuChilds.push(menu)
              }
            }
          }
        })
      }
    },
  },
}
</script>

<style scoped>

</style>